Loading...
Searching...
No Matches
pcl::MEstimatorSampleConsensus< PointT > Class Template Reference
Module sample_consensus

MEstimatorSampleConsensus represents an implementation of the MSAC (M-estimator SAmple Consensus) algorithm, as described in: "MLESAC: A new robust estimator with application to estimating image geometry", P.H.S. More...

`#include <pcl/sample_consensus/msac.h>`

Inheritance diagram for pcl::MEstimatorSampleConsensus< PointT >:

## Public Types

using | Ptr = shared_ptr<MEstimatorSampleConsensus<PointT> >
using | ConstPtr = shared_ptr<const MEstimatorSampleConsensus<PointT> >
Public Types inherited from pcl::SampleConsensus< PointT >
using | Ptr
using | ConstPtr

## Public Member Functions

| MEstimatorSampleConsensus (const SampleConsensusModelPtr &model)
| MSAC (M-estimator SAmple Consensus) main constructor.
| MEstimatorSampleConsensus (const SampleConsensusModelPtr &model, double threshold)
| MSAC (M-estimator SAmple Consensus) main constructor.
bool | computeModel (int debug_verbosity_level=0) override
| Compute the actual model and find the inliers.
Public Member Functions inherited from pcl::SampleConsensus< PointT >
void | setSampleConsensusModel (const SampleConsensusModelPtr &model)
| Set the Sample Consensus model to use.
SampleConsensusModelPtr | getSampleConsensusModel () const
| Get the Sample Consensus model used.
virtual | ~SampleConsensus ()=default
| Destructor for base SAC.
void | setDistanceThreshold (double threshold)
| Set the distance to model threshold.
double | getDistanceThreshold () const
| Get the distance to model threshold, as set by the user.
void | setMaxIterations (int max_iterations)
| Set the maximum number of iterations.
int | getMaxIterations () const
| Get the maximum number of iterations, as set by the user.
void | setProbability (double probability)
| Set the desired probability of choosing at least one sample free from outliers.
double | getProbability () const
| Obtain the probability of choosing at least one sample free from outliers, as set by the user.
void | setNumberOfThreads (const int nr_threads=-1)
| Set the number of threads to use or turn off parallelization.
int | getNumberOfThreads () const
| Get the number of threads, as set by the user.
virtual bool | refineModel (const double sigma=3.0, const unsigned int max_iterations=1000)
| Refine the model found.
void | getRandomSamples (const IndicesPtr &indices, std::size_t nr_samples, std::set< index_t > &indices_subset)
| Get a set of randomly selected indices.
void | getModel (Indices &model) const
| Return the best model found so far.
void | getInliers (Indices &inliers) const
| Return the best set of inliers found so far for this model.
void | getModelCoefficients (Eigen::VectorXf &model_coefficients) const
| Return the model coefficients of the best model found so far.

## Additional Inherited Members

Protected Member Functions inherited from pcl::SampleConsensus< PointT >
double | rnd ()
| Boost-based random number generator.
Protected Attributes inherited from pcl::SampleConsensus< PointT >
SampleConsensusModelPtr | sac_model_
| The underlying data model used (i.e.
Indices | model_
| The model found after the last computeModel () as point cloud indices.
Indices | inliers_
| The indices of the points that were chosen as inliers after the last computeModel () call.
Eigen::VectorXf | model_coefficients_
| The coefficients of our model computed directly from the model found.
double | probability_
| Desired probability of choosing at least one sample free from outliers.
int | iterations_
| Total number of internal loop iterations that we've done so far.
double | threshold_
| Distance to model threshold.
int | max_iterations_
| Maximum number of iterations before giving up.
int | threads_
| The number of threads the scheduler should use, or a negative number if no parallelization is wanted.
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm.
std::shared_ptr< boost::uniform_01< boost::mt19937 > > | rng_
| Boost-based random number generator distribution.

## Detailed Description

template<typename PointT>
class pcl::MEstimatorSampleConsensus< PointT >

MEstimatorSampleConsensus represents an implementation of the MSAC (M-estimator SAmple Consensus) algorithm, as described in: "MLESAC: A new robust estimator with application to estimating image geometry", P.H.S.

Torr and A. Zisserman, Computer Vision and Image Understanding, vol 78, 2000. The difference to RANSAC is how the quality of a model is computed: RANSAC counts the number of inliers, given a threshold. The more inliers, the better the model is - it does not matter how close the inliers actually are to the model, as long as they are within the threshold. MSAC changes this by using the sum of all point-model distances as the quality measure, however outliers only add the threshold instead of their true distance. This method can lead to better results compared to RANSAC.

Author
  Radu B. Rusu

Definition at line 60 of file msac.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::MEstimatorSampleConsensus< PointT >::ConstPtr = shared_ptr<const MEstimatorSampleConsensus<PointT> >

Definition at line 66 of file msac.h.

## Ptr

template<typename PointT>

using pcl::MEstimatorSampleConsensus< PointT >::Ptr = shared_ptr<MEstimatorSampleConsensus<PointT> >

Definition at line 65 of file msac.h.

## Constructor & Destructor Documentation

## MEstimatorSampleConsensus() [1/2]

template<typename PointT>

pcl::MEstimatorSampleConsensus< PointT >::MEstimatorSampleConsensus | ( | const SampleConsensusModelPtr & | model | ) |

inline

MSAC (M-estimator SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model

Definition at line 80 of file msac.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## MEstimatorSampleConsensus() [2/2]

template<typename PointT>

pcl::MEstimatorSampleConsensus< PointT >::MEstimatorSampleConsensus | ( | const SampleConsensusModelPtr & | model,
|  | double | threshold )

inline

MSAC (M-estimator SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model
  [in] | threshold | distance to model threshold

Definition at line 91 of file msac.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## Member Function Documentation

## computeModel()

template<typename PointT>

bool pcl::MEstimatorSampleConsensus< PointT >::computeModel | ( | int | debug_verbosity_level = 0 | ) |

override virtual

Compute the actual model and find the inliers.

Parameters

  [in] | debug_verbosity_level | enable/disable on-screen debug information and set the verbosity level

Implements pcl::SampleConsensus< PointT >.

Definition at line 48 of file msac.hpp.

References pcl::SampleConsensus< PointT >::inliers_, pcl::SampleConsensus< PointT >::iterations_, pcl::SampleConsensus< PointT >::max_iterations_, pcl::SampleConsensus< PointT >::model_, pcl::SampleConsensus< PointT >::model_coefficients_, pcl::SampleConsensus< PointT >::probability_, pcl::SampleConsensus< PointT >::sac_model_, and pcl::SampleConsensus< PointT >::threshold_.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/msac.h
- pcl/sample_consensus/impl/msac.hpp